//package cn.sagacloud.android.cadengine.items
//
//import cn.sagacloud.android.cadengine.types.Door
//
///**
// * 门 Item
// *
// * @author 付国宝
// */
//class DoorItem {
//    /** 门数据 */
//    var data: Door? = null
//    /** 门轮廓线坐标list  */
//    private val pointArr = ArrayList<SPoint>()
//    /** 门长度 */
//    private var r: Double? = null
//    /** 角度  */
//    private var ang: Double? = null
//    /** 旋转点 */
//    private var p = SPoint(0,0)
//    /** 旋转起始角度 */
//    private var startAng: Double = -Math.PI / 2
//    /** 旋转结束角度 */
//    private var endAng = 0
//
//    /**
//     * 构造函数
//     *
//     * @param data      门数据
//     */
//    constructor(data: Door){
//        this.data = data
//        if (this.data?.OutLine!!.size > 0) {
////            this.pointArr = this.data.OutLine[0].map(t => {
////                return SPoint(t.X, -t.Y)
////            })
//            var p1 = this.pointArr[0]
//            var p2 = this.pointArr[1]
////            var fo = Math.atan( -this.data.FaceDirection.Y / this.data.FaceDirection.X)
//            // 两点间距离
////            this.r = Math.sqrt(Math.pow(p1.x - p2.x, 2) + Math.pow(p1.y - p2.y, 2))
//            // 门朝向角度
////            this.ang = this.data.FaceDirection.X > 0 ? fo : fo + Math.PI
//            // 旋转点
//            if (Math.abs(this.data.HandDirection.X) > Math.abs(this.data.HandDirection.Y)){
//                if (this.data.HandDirection.X > 0) {
//                    if (p1.x > p2.x) {
//                        this.p = p1
//                        // this.number = 1 //
//                    } else {
//                        this.p = p2
//                        // this.number = 2
//                    }
//                } else {
//                    if (p1.x < p2.x) {
//                        this.p = p1
//                        // this.number = 3 //
//                    } else {
//                        this.p = p2
//                        // this.number = 4 //
//                    }
//                }
//            }else{
//                if (this.data.HandDirection.Y > 0) {
//                    if (p1.y > p2.y) {
//                        this.p = p1
//                        // this.number = 5 //
//                    } else {
//                        this.p = p2
//                        // this.number = 6
//                    }
//                } else {
//                    if (p1.y < p2.y) {
//                        this.p = p1
//                        // this.number = 7
//                    } else {
//                        this.p = p2
//                        // this.number = 8
//                    }
//                }
//            }
//        }
//    } // Constructor
//
//    /**
//     * Item绘制操作
//     *
//     * @param   painter       painter对象
//     * @param   rect          绘制区域
//     */
//    fun onDraw(painter: SPainter, rect/*?*/: SRect){
//        if (this.visible) {
//            painter.translate(this.p.x, this.p.y)
//            painter.rotate(this.ang)
//            painter.pen.lineWidth = 100
//            painter.pen.color = Opt.doorColor
//            painter.drawLine(0, 0, this.r, 0)
//
//            painter.pen.lineDash = [50, 50]
//            painter.drawArc( -this.r,  -this.r, this.r * 2, this.r * 2, this.startAng, this.endAng)
//        }
//    } // Function onDraw()
//} // Class DoorItem