package cn.sagacloud.android.cadengine.types

import android.graphics.PointF

/**
 * 柱子 Item 类
 *
 * @author 付国宝
 */
class Column {
    /** 名称  */
    var Name: String? = null
    /** 轮廓线  */
    var OutLine: ArrayList<ArrayList<PointF>>? = null
    /** 房间边界  */
    var RoomBoundary: Boolean? = null
    /** 位置  */
    var Location: Place? = null
    /** 模型id(外键)    */
    var ModelId: String? = null
    /** 对应Revit模型id */
    var SourceId: String? = null
} // Class Column