package cn.sagacloud.android.cadengine.types

import android.graphics.PointF

/**
 * 空间 item 类
 *
 * @author 付国宝
 */
class Space {
    /** 轮廓线段    */
    var BoundarySegments: ArrayList<String>? = null
    /** 位置  */
    var Location: Place? = null
    /** 模型id(外键)    */
    var ModelId: String? = null
    /** 名称  */
    var Name: String? = null
    /** 轮廓线  */
    var OutLine: ArrayList<ArrayList<PointF>>? = null
    /** 对应Revit模型id */
    var SourceId: String? = null
    /** 补充信息    */
    var Tag: String? = null
} // Class Space