package cn.sagacloud.android.cadengine.types

import android.graphics.PointF

/**
 * 门 Item 类
 *
 * @author 付国宝
 */
class Door {
    /** 面朝方向  */
    var FaceDirection: PointF? = null
    /** 把手方向  */
    var HandDirection: PointF? = null
    /** 位置  */
    var Location: Place? = null
    /** 模型id(外键)    */
    var ModelId: String? = null
    /** 名称  */
    var Name: String? = null
    /** 轮廓线  */
    var OutLine: ArrayList<ArrayList<PointF>>? = null
    /** 拥有者的RevitId */
    var Owner: String? = null
    /** 对应Revit模型id */
    var SourceId: String? = null
    /** 厚度  */
    var Thick: Double? = null
    /** 所属墙 */
    var WallId: String? = null
    /** 宽度  */
    var Width: String? = null

} // Class Door